URLClassLoader

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.net
Class URLClassLoader

    java.lang.Object
      java.lang.ClassLoader
          java.security.SecureClassLoader
              java.net.URLClassLoader

    public class URLClassLoader

extends SecureClassLoader

This class loader is used to load classes and resources from a search path of URLs referring to both JAR files and directories. Any URL that ends with a '/' is assumed to refer to a directory. Otherwise, the URL is assumed to refer to a JAR file which will be opened as needed.

The AccessControlContext of the thread that created the instance of URLClassLoader will be used when subsequently loading classes and resources.

The classes that are loaded are by default granted permission only to access the URLs specified when the URLClassLoader was created.

Since:
  1.2
Version:
  1.72 10/17/00
Author:
  David Connelly

Constructor Summary
`URLClassLoader(URL[] urls)` Constructs a new URLClassLoader for the specified URLs using the default delegation parent `ClassLoader`.
`URLClassLoader(URL[] urls, ClassLoader parent)` Constructs a new URLClassLoader for the given URLs.
`URLClassLoader(URL[] urls, ClassLoader parent, URLStreamHandlerFactory factory)` Constructs a new URLClassLoader for the specified URLs, parent class loader, and URLStreamHandlerFactory.

Method Summary
`URL` | `findResource(String name)` Finds the resource with the specified name on the URL search path.
`Enumeration` | `findResources(String name)` Returns an Enumeration of URLs representing all of the resources on the URL search path having the specified name.
`URL[]` | `getURLs()` Returns the search path of URLs for loading classes and resources.
`static URLClassLoader` | `newInstance(URL[] urls)` Creates a new instance of URLClassLoader for the specified URLs and default parent class loader.
`static URLClassLoader` | `newInstance(URL[] urls, ClassLoader parent)` Creates a new instance of URLClassLoader for the specified URLs and parent class loader.

Methods inherited from class java.lang.ClassLoader
`clearAssertionStatus, getParent, getResource, getResourceAsStream, getResources, getSystemClassLoader, getSystemResource, getSystemResourceAsStream, getSystemResources, loadClass, setClassAssertionStatus, setDefaultAssertionStatus, setPackageAssertionStatus`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### URLClassLoader

    public URLClassLoader(URL[] urls,
                          ClassLoader parent)

  Constructs a new URLClassLoader for the given URLs. The URLs will be searched in the order specified for classes and resources after first searching in the specified parent class loader. Any URL that ends with a '/' is assumed to refer to a directory. Otherwise, the URL is assumed to refer to a JAR file which will be downloaded and opened as needed.

  If there is a security manager, this method first calls the security manager's `checkCreateClassLoader` method to ensure creation of a class loader is allowed.

  Parameters:
    `urls` - the URLs from which to load classes and resources
    `parent` - the parent class loader for delegation
  Throws:
    `SecurityException` - if a security manager exists and its `checkCreateClassLoader` method doesn't allow creation of a class loader.
  See Also:
    `SecurityManager.checkCreateClassLoader()`

### URLClassLoader

    public URLClassLoader(URL[] urls)

  Constructs a new URLClassLoader for the specified URLs using the default delegation parent `ClassLoader`. The URLs will be searched in the order specified for classes and resources after first searching in the parent class loader. Any URL that ends with a '/' is assumed to refer to a directory. Otherwise, the URL is assumed to refer to a JAR file which will be downloaded and opened as needed.

  If there is a security manager, this method first calls the security manager's `checkCreateClassLoader` method to ensure creation of a class loader is allowed.

  Parameters:
    `urls` - the URLs from which to load classes and resources
  Throws:
    `SecurityException` - if a security manager exists and its `checkCreateClassLoader` method doesn't allow creation of a class loader.
  See Also:
    `SecurityManager.checkCreateClassLoader()`

### URLClassLoader

    public URLClassLoader(URL[] urls,
                          ClassLoader parent,
                          URLStreamHandlerFactory factory)

  Constructs a new URLClassLoader for the specified URLs, parent class loader, and URLStreamHandlerFactory. The parent argument will be used as the parent class loader for delegation. The factory argument will be used as the stream handler factory to obtain protocol handlers when creating new URLs.

  If there is a security manager, this method first calls the security manager's `checkCreateClassLoader` method to ensure creation of a class loader is allowed.

  Parameters:
    `urls` - the URLs from which to load classes and resources
    `parent` - the parent class loader for delegation
    `factory` - the URLStreamHandlerFactory to use when creating URLs
  Throws:
    `SecurityException` - if a security manager exists and its `checkCreateClassLoader` method doesn't allow creation of a class loader.
  See Also:
    `SecurityManager.checkCreateClassLoader()`

Method Detail

### getURLs

    public URL[] getURLs()

  Returns the search path of URLs for loading classes and resources. This includes the original list of URLs specified to the constructor, along with any URLs subsequently appended by the addURL() method.

  Returns:
    the search path of URLs for loading classes and resources.

### findResource

    public URL findResource(String name)

  Finds the resource with the specified name on the URL search path.

  Parameters:
    `name` - the name of the resource
  Returns:
    a `URL` for the resource, or `null` if the resource could not be found.

### findResources

    public Enumeration findResources(String name)
                              throws IOException

  Returns an Enumeration of URLs representing all of the resources on the URL search path having the specified name.

  Parameters:
    `name` - the resource name
  Returns:
    an `Enumeration` of `URL`s
  Throws:
    `IOException` - if an I/O exception occurs

### newInstance

    public static URLClassLoader newInstance(URL[] urls,
                                             ClassLoader parent)

  Creates a new instance of URLClassLoader for the specified URLs and parent class loader. If a security manager is installed, the `loadClass` method of the URLClassLoader returned by this method will invoke the `SecurityManager.checkPackageAccess` method before loading the class.

  Parameters:
    `urls` - the URLs to search for classes and resources
    `parent` - the parent class loader for delegation
  Returns:
    the resulting class loader

### newInstance

    public static URLClassLoader newInstance(URL[] urls)

  Creates a new instance of URLClassLoader for the specified URLs and default parent class loader. If a security manager is installed, the `loadClass` method of the URLClassLoader returned by this method will invoke the `SecurityManager.checkPackageAccess` before loading the class.

  Parameters:
    `urls` - the URLs to search for classes and resources
  Returns:
    the resulting class loader

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD